<!DOCTYPE html>
<html lang="en">
<head>
  <title>Task 63</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Voucher</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="voucher-code">Mã Voucher</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="discount">Phần trăm giảm giá</label>
		</div>
		<div class="col-sm-9">
		  <input type="number" id="input-discount" name="discount" placeholder="Discount" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-3">
			<button id="create-data" class="btn btn-info">Create Data</button>
		</div>
		<div class="col-sm-3">
			<button id="delete-all-data" class="btn btn-danger">Delete All Data</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã giảm giá</th>
        <th>Phần trăm giảm giá</th>
        <th>Ghi Chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
      </tr>
  </table>
</div>
<script>
$(document).ready(function(){
	/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
	var gId = "";
	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	var table = $("#user-table").DataTable({
		"columns": [
			{"data":"id"},
			{"data":"maVoucher"},
			{"data":"phanTramGiamGia"},
			{"data":"ghiChu"},
			{"data":"ngayTao"},
			{"data":"ngayCapNhat"},
		]
	})
	$.ajax({
		url: "http://localhost:8080/api/vouchers",
		type: "GET",
		dataType: "json",
		success: function(res){
			console.log(res);
			table.clear();
			table.rows.add(res);
			table.draw();
		},
		error: function(err){
			console.log(err.response);
		}
	})

	$(document).on("click", "tr", function(){
		onBtnDetailClick(this) ;
	});
	//Gán event handler cho sự kiện update data
	$(document).on("click", "#save_data", function (){
        onBtnSaveDataClick();
    });
	//Gán event handler cho sự kiện create data
	$(document).on("click", "#create-data", function (){
        onBtnCreateDataClick();
    });
	//Gán event handler cho sự kiện delete 1 data 
	$(document).on("click", "#delete-data", function (){
		onBtnDeleteClick();
	});
	//Gán event handler cho sự kiện delete all data 
	$(document).on("click", "#delete-all-data", function (){
		onBtnAllDeleteClick();
	});

	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
	function onBtnDetailClick(paramElement){
		// gFormMode = gFORM_MODE_UPDATE;
		var vRowSelected = $(paramElement).closest("tr");
		var vTable = $("#user-table").DataTable();
		var vDataRow = vTable.row(vRowSelected).data() ;
		gId = vDataRow.id;
		$.ajax({
			url: "http://localhost:8080/api/vouchers/" + gId,
			type: "GET",
			dataType : "json",
			success: function(res){
				console.log(res);
				$("#input-voucher-code").val(res.maVoucher);
				$("#input-discount").val(res.phanTramGiamGia) ;
				$("#input-note").val(res.ghiChu);
				if(res.ngayTao !== null){
					let vCreateDate = res.ngayTao.slice(6, 10) + "-" + res.ngayTao.slice(3,5) + "-" + res.ngayTao.slice(0, 2);
					$("#input-createDate").val(vCreateDate);
				} else {
					$("#input-createDate").val(null);
				}
				if(res.ngayCapNhat !== null){
				    let vUpdateDate = res.ngayCapNhat.slice(6, 10) + "-" + res.ngayCapNhat.slice(3,5) + "-" + res.ngayCapNhat.slice(0, 2);
				    $("#input-updateDate").val(vUpdateDate);
				} else {
				    $("#input-updateDate").val(null);
				}
				$(".pull-right"). html(`
				    <div class="col-sm-3">
				        <button id="save_data" class="btn btn-info">Update Data</button>
				    </div>
				    <div class="col-sm-3">
				        <button id="delete-data" class="btn btn-danger">Delete Data</button>
				    </div>`
				)
			},
			error: function(err){
				console.log(err.response);
			}
		});
	}

	function onBtnSaveDataClick(){
		let vObjectRequest = {
			id: gId,
			maVoucher: $("#input-voucher-code").val(),
			phanTramGiamGia: $("#input-discount").val(),
			ghiChu: $("#input-note").val(),
		};
		$.ajax({
			url:"http://localhost:8080/api/vouchers/" + gId,
			contentType: "application/json; charset=UTF-8",
			type: "PUT",
			dataType: "json",
			data: JSON.stringify(vObjectRequest),
			success: function(res){
				window.location.reload();
			},
			error: function(err){
				console.log(err.response);
			}
		});
	} 

	function onBtnCreateDataClick(){
		let vObjectRequest = {
			maVoucher: $("#input-voucher-code").val(),
			phanTramGiamGia: $("#input-discount").val(),
			ghiChu: $("#input-note").val(),
		};
		$.ajax({
			url:"http://localhost:8080/api/vouchers",
			contentType: "application/json; charset=UTF-8",
			type: "POST",
			dataType: "json",
			data: JSON.stringify(vObjectRequest),
			success: function(res){
				console.log(res);
				window.location.reload();
			},
			error: function(err){
				console.log(err.response);
			}
		});
	} 

	function onBtnDeleteClick(){
		if(confirm( "Bạn có muốn xóa?") == true){
			$.ajax({
				url: "http://localhost:8080/api/vouchers/" + gId,
				type: "DELETE",
				dataType : "json",
				success: function(res){
					window.location.reload();
				},
				error: function(err){
					console.log(err.response);
				}
			});
		};
	}
	
	function onBtnAllDeleteClick(){
		if(confirm( "Bạn có muốn xóa toàn bộ dữ liệu voucher?") == true) {
			$.ajax({
				url: "http://localhost:8088/api/vouchers",
				type: "DELETE",
				dataType : "json",
				success: function(res){
					window.location.reload();
				},
				error: function(err){
					console.log(err.response);
				}
			});
		};
	}
	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		

		
})
</script>
</body>
</html>
